#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include "partition.h"

int main(int argc, char **argv)
{
	int fd, r, i;
	partition_header header;

	if (argc != 2)
	{
		fprintf(stderr, "%s [pitfilename]\n", argv[0]);
		return 1;
	}

	fd = open(argv[1], O_RDONLY);
	if (fd < 0)
	{
		fprintf(stderr, "%s: failed to open %s\n", argv[0], argv[1]);
		return 1;
	}

	r = read(fd, &header, sizeof header);
	if (r != sizeof header)
		return 1;

	printf("PartName, FileName, DeltaName, BinType, DevType, Id, Attr , UpdateAttr, BlkSize, BlkLen, Offset, FileSize\n");

	for (i=0; i<header.nCount; i++)
	{
		partition_info part;

		r = read(fd, &part, sizeof part);
		if (r != sizeof part)
			break;

		printf("%s, %s, %s, %d, %d, %d, %d, %d, %u, %u, %u, %u\n", part.szName, part.szFileName, part.szDeltaName,
			part.nBinType, part.nDevType, part.nID, part.nAttribute, part.nUpdateAttr, part.dwBlkSize, part.dwBlkLen, part.dwOffset, part.dwFileSize);
	}

	close(fd);

	return 0;
}
